<?php
/**
 * @category    Pinpoint
 * @package     Pinpoint_CustomerNotes
 * @copyright   Copyright (c) 2019 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Ahmed Goda <hello@pinpointdesigns.co.uk>
 */

namespace Pinpoint\CustomerNotes\Api\Data;

/**
 * Interface CustomerNoteInterface
 */
interface CustomerNoteInterface
{
    const ID          = 'note_id';
    const CUSTOMER_ID = 'customer_id';
    const AUTHOR      = 'author';
    const DESCRIPTION = 'description';
    const CREATED_AT  = 'created_at';
    const UPDATED_AT  = 'updated_at';

    /**
     * @return int
     */
    public function getId();

    /**
     * @return string
     */
    public function getAuthor();

    /**
     * @return int
     */
    public function getCustomerId();

    /**
     * @return string
     */
    public function getDescription();

    /**
     * @return string
     */
    public function getCreatedAt();

    /**
     * @return string
     */
    public function getUpdatedAt();

    /**
     * @param string $author
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function setAuthor(string $author);

    /**
     * @param int $customerId
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function setCustomerId(int $customerId);

    /**
     * @param string $description
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function setDescription(string $description);

    /**
     * @param string $createdAt
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function setCreatedAt(string $createdAt);

    /**
     * @param string $updatedAt
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function setUpdatedAt(string $updatedAt);
}
