<?php
/**
 * @category    Pinpoint
 * @package     Pinpoint_CustomerNotes
 * @copyright   Copyright (c) 2019 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Ahmed Goda <hello@pinpointdesigns.co.uk>
 */

namespace Pinpoint\CustomerNotes\Api;

use Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface;

/**
 * Interface NoteRepositoryInterface
 */
interface NoteRepositoryInterface
{
    /**
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface[]
     */
    public function getList();

    /**
     * @param int $noteId
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function getNoteById(int $noteId);

    /**
     * @param \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface $note
     * @return \Pinpoint\CustomerNotes\Api\Data\CustomerNoteInterface
     */
    public function saveNote(CustomerNoteInterface $note);

    /**
     * @param int $noteId
     * @return void
     */
    public function deleteNoteById(int $noteId);
}
